#pragma once

#include <vector>
#include <memory>
using namespace std;

// PAS D'INCLUDE PARTICULIER DANS CE FICHIER (a part la std lib)

/*

  Les objets qui doivent afficher quelque chose sont ceux qui observent
  Ils derivent donc de la classe Observateur
  
*/

class Observateur {
    public:
    virtual void update(float r) = 0;
};

/*

   Les objets qui ont quelque chose a faire afficher sont ceux qui diffusent
   Ils derivent donc de la classe Diffuseur
   
*/
class Diffuseur {
   public:
   void notifier(float r) {
       for (auto a : abonnes) {
           a->update(r);
       }
   };
   void abonne(const shared_ptr<Observateur>& o) {
       abonnes.push_back(o);
   };
   private:
      vector<shared_ptr<Observateur>> abonnes;
};
